@echo off
::
:: Lines beginning with "::" are inactive.
::
::-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@-<
::
:: Purpose:
:: ~~~~~~~~
:: This batch code is simply a frontend for "BATCHMAN CLS" (clearing the
:: screen via Batchman, allowing for different background and text colors).
::
::-------------------------------------------------------------------------<
::
:: Requirements:
:: ~~~~~~~~~~~~~
:: * MS-DOS [*] Protected-mode ... (with Win9x ... running)
::          [*] Real-mode ........ (with Win9x NOT running)
:: * MS-DOS External Command Program(s):
::   -     FIND.EXE
::   - BATCHMAN.COM (v1.1) (by Michael J Mefford)
::                  (MD5:  753c4c21960b59f5f59ad7e147ff081d  BATCHMAN.COM)
::                  ftp://ftp.elf.stuba.sk/pub/pc/utiltask/batchman.zip
::
::-------------------------------------------------------------------------<
::
:: Notes:
:: ~~~~~~
:: * For usage, type "CLSBM /?".
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: Usage: CLSBM [[@]#]
::
::        @ - Background Color [Black(0) if absent]
::        # - Foreground Color (text)
::
::              /---------------------------------------------------------\
:: Color Chart: | Dark Colors | Light Colors | Dark Colors | Light Colors |
::              | ----------- | ------------ | ----------- | ------------ |
::              |   Black - 0 | 8 - Gray     |  Maroon - 4 | C - Red      |
::              |    Navy - 1 | 9 - Blue     |  Purple - 5 | D - Fuchsia  |
::              |   Green - 2 | A - Lime     |   Olive - 6 | E - Yellow   |
::              |    Teal - 3 | B - Aqua     |  Silver - 7 | F - White    |
::              \---------------------------------------------------------/
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: * If "@" is not supplied (while "#" is), the background color defaults to
::   0 (black).
::
:: * "@" and "#" must be different so as to avoid the unreadable situation
::   where the text color is the same as the background color.            ;)
::
:: * Under real-mode DOS (with Windows NOT running), any color combinations
::   where the background color is one of these (@: 8 9 A B C D E F) colors
::   will produce a blinking text effect.
::
:: * Ironically, in real-mode DOS the color pairs
::   (@#: 88 99 AA BB CC DD EE FF) actually produce readable text on screen
::   (though blinking).  This program does not allow these color combos,
::   however, since it does know whether it is being run under a real-mode
::   DOS environment or a protected-mode (with Windows running) DOS
::   environment.
::
:: * Under real-mode DOS any of these color combinations
::   (@#: 80 91 A2 B3 C4 D5 E6 F7) will cause an effect where nothing
::   appears on screen (there's actually blinking text that is the same
::   color as the background).
::
::-------------------------------------------------------------------------<
::
:: About:                                               (06-06-2009)
:: ~~~~~~
:: CLSBM.BAT (v1.3)
::
::      Bla
::      P.O. Box NUL
::      Valley View, Ohio 44125 USA
::
::      E-Mail:   Blaware@FastMail.fm
::      Webpage:  http://www.NUL.nul/index.html
::
:: Feed the birds.  (Why?)  Well, they haven't pecked your eyes out!
::
::-#######################################################################-<
::
echo z | find "z" > NUL
batchman month
if not errorlevel 1 goto MESSAGE
if .%1.==.. goto 0J
if not .%2.==.. goto HELP
set BZ9=batchman cecho
echo -h/H?-?/?--HELP | find /i "%1" > NUL
if not errorlevel 1 goto HELP
set BZ6=
echo 123456789ABCDEF | find /i "%1" > NUL
if not errorlevel 1 goto 0G
echo 0102030405060708090A0B0C0D0E0F1012131415161718191A1B1C1D1E1F | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo 2021232425262728292A2B2C2D2E2F3031323435363738393A3B3C3D3E3F | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo 4041424345464748494A4B4C4D4E4F5051525354565758595A5B5C5D5E5F | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo 6061626364656768696A6B6C6D6E6F7071727374757678797A7B7C7D7E7F | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo 8081828384858687898A8B8C8D8E8F9091929394959697989A9B9C9D9E9F | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo A0A1A2A3A4A5A6A7A8A9ABACADAEAFB0B1B2B3B4B5B6B7B8B9BABCBDBEBF | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo C0C1C2C3C4C5C6C7C8C9CACBCDCECFD0D1D2D3D4D5D6D7D8D9DADBDCDEDF | find /i "%1" > NUL
if not errorlevel 1 goto 0H
echo E0E1E2E3E4E5E6E7E8E9EAEBECEDEFF0F1F2F3F4F5F6F7F8F9FAFBFCFDFE | find /i "%1" > NUL
if not errorlevel 1 goto 0H
goto HELP
::
:MESSAGE
echo.
echo  CLSBM.BAT -- Frontend for "BATCHMAN CLS" (clearing the screen via Batchman,
echo               allowing for different background and text colors).
echo               Type "CLSBM /?" for usage.
echo.
echo               Requirements: BATCHMAN.COM (v1.1)
echo.
goto 0I
::
:HELP
set BZ8=
set BZ7=
cls
echo.
%BZ9% c 0Fh  
%BZ9% F0h                      Ŀ                       
%BZ9% c 0Fh  
%BZ9% F0h    BATCHMAN CLEAR SCREEN FRONTEND Ŀ   
%BZ9% c 0Fh  
%BZ9% F0h    USAGE: CLSBM [[@]#]   @=BACKGROUND {Black(0) if absent}; #=FOREGROUND    
%BZ9% c 0Fh  
%BZ9% F0h   Ĵ   
%BZ9% c 0Fh  
%BZ9% F0h        Black - 0      8 - Gray          Maroon - 4      C - Red          
%BZ9% c 0Fh  
%BZ9% F0h         Navy - 1      9 - Blue          Purple - 5      D - Fuchsia      
%BZ9% c 0Fh  
%BZ9% F0h        Green - 2      A - Lime           Olive - 6      E - Yellow       
%BZ9% c 0Fh  
%BZ9% F0h         Teal - 3      B - Aqua          Silver - 7      F - White        
%BZ9% c 0Fh  
%BZ9% F0h      
::
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 0Fh %BZ8%
%BZ9% c F0h  
%BZ9% c 8Fh %BZ8%
%BZ9% c F0h  
%BZ9% c 4Fh %BZ8%
%BZ9% c F0h  
%BZ9% c CFh %BZ8%
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 0Fh        0       
%BZ9% c F0h  
%BZ9% c 8Fh        8       
%BZ9% c F0h  
%BZ9% c 4Fh        4       
%BZ9% c F0h  
%BZ9% c CFh        C       
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 0Fh %BZ7%
%BZ9% c F0h  
%BZ9% c 8Fh %BZ7%
%BZ9% c F0h  
%BZ9% c 4Fh %BZ7%
%BZ9% c F0h  
%BZ9% c CFh %BZ7%
%BZ9% F0h     
::
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 1Fh %BZ8%
%BZ9% c F0h  
%BZ9% c 9Fh %BZ8%
%BZ9% c F0h  
%BZ9% c 5Fh %BZ8%
%BZ9% c F0h  
%BZ9% c DFh %BZ8%
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 1Fh        1       
%BZ9% c F0h  
%BZ9% c 9Fh        9       
%BZ9% c F0h  
%BZ9% c 5Fh        5       
%BZ9% c F0h  
%BZ9% c DFh        
%BZ9% c D0h D
%BZ9% c DFh        
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 1Fh %BZ7%
%BZ9% c F0h  
%BZ9% c 9Fh %BZ7%
%BZ9% c F0h  
%BZ9% c 5Fh %BZ7%
%BZ9% c F0h  
%BZ9% c DFh %BZ7%
%BZ9% F0h     
::
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 2Fh %BZ8%
%BZ9% c F0h  
%BZ9% c AFh %BZ8%
%BZ9% c F0h  
%BZ9% c 6Fh %BZ8%
%BZ9% c F0h  
%BZ9% c EFh %BZ8%
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 2Fh        2       
%BZ9% c F0h  
%BZ9% c AFh        
%BZ9% c A0h A
%BZ9% c AFh        
%BZ9% c F0h  
%BZ9% c 6Fh        6       
%BZ9% c F0h  
%BZ9% c EFh        
%BZ9% c E0h E
%BZ9% c EFh        
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 2Fh %BZ7%
%BZ9% c F0h  
%BZ9% c AFh %BZ7%
%BZ9% c F0h  
%BZ9% c 6Fh %BZ7%
%BZ9% c F0h  
%BZ9% c EFh %BZ7%
%BZ9% F0h     
::
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 3Fh %BZ8%
%BZ9% c F0h  
%BZ9% c BFh %BZ8%
%BZ9% c F0h  
%BZ9% c 7Fh %BZ8%
%BZ9% c F0h  
%BZ9% c F0h Ŀ
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 3Fh        3       
%BZ9% c F0h  
%BZ9% c BFh        
%BZ9% c B0h B
%BZ9% c BFh        
%BZ9% c F0h  
%BZ9% c 7Fh        7       
%BZ9% c F0h  
%BZ9% c F0h        
%BZ9% c F0h F
%BZ9% c F0h        
%BZ9% F0h     
%BZ9% c 0Fh  
%BZ9% c F0h    
%BZ9% c 3Fh %BZ7%
%BZ9% c F0h  
%BZ9% c BFh %BZ7%
%BZ9% c F0h  
%BZ9% c 7Fh %BZ7%
%BZ9% c F0h  
%BZ9% c F0h 
%BZ9% F0h     
::
%BZ9% c 0Fh  
%BZ9% F0h                                                                               
echo.
goto 0I
::
:0G
set BZ6=0
::
:0H
batchman cls %BZ6%%1h
::
:0I
for %%A in (BZ9 BZ8 BZ7 BZ6) do set %%A=
goto END
::
:0J
batchman cls
::
:END