@echo off
::
:: Lines beginning with "::" are inactive.
::
::-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@-<
::
:: Purpose:
:: ~~~~~~~~
:: This batch code will detect if a drive exists with a disk present and
:: writable, and SET the "DrvWrite" environment variable.
::
::-------------------------------------------------------------------------<
::
:: Requirements:
:: ~~~~~~~~~~~~~
:: * MS-DOS [*] Protected-mode ... (with Win9x ... running)
::          [*] Real-mode ........ (with Win9x NOT running)
:: * MS-DOS External Command Program(s):
::   -     FIND.EXE
::   - FREETEST.COM (by Eric Auer)
::                  (MD5:  207e93220ea6fa033d3f48a30ddc5a64  FREETEST.COM)
::                  http://www.coli.uni-saarland.de/~eric/
::                   stuff/soft/specials/free-disk-space-tester-freetest.zip
::   -    PKZIP.EXE (v2.50) (PKWARE)
::                  (MD5:  fb3a1925d98c6235d611a65595542c46  PKZIP.EXE)
::                  ftp://ftp.elf.stuba.sk/pub/pc/pack/pk250dos.exe
::                  http://www.pkware.com/
::
::-------------------------------------------------------------------------<
::
:: Notes:
:: ~~~~~~
:: * For usage, type "DRVWRITE /?".
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
::                                                   /
::                                                   | Example: DRVWRITE a
::        Usage: DRVWRITE [letter]                   \---------------------/
::               DRVWRITE ... Case iNsEnSiTiVe (except cannot be "drvwRite")
::                 letter ... Drive letter A-Z (except B)
::       Output:   YES/NO ... ECHOed to screen
::
::                                                   /
::  Batch Usage: drvwRite [letter]                   | Example: drvwRite F
::  ------------ drvwRite ... Case sEnSiTiVe         \---------------------/
::                 letter ... Drive letter A-Z (except B)
:: Batch Output:      1/0 ... Value SET to "DrvWrite" EV (1=YES,0=NO)
:: -------------
::
:: Requirements: FREETEST.COM / PKZIP.EXE (v2.50)
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: * For command-line usage:  If the test result is positive, "YES" is
::   ECHOed to screen.  If negative, "NO" is ECHOed to screen.
::
:: * For batch usage (drvwRite):  If the test result is positive, the
::   environment variable %DrvWrite% is given a value of 1.  If negative, it
::   is given a value of 0.
::
:: * This batch code was partially adapted from code found here:
::   http://www.ericphelps.com/
::
::-------------------------------------------------------------------------<
::
:: About:                                               (06-06-2009)
:: ~~~~~~
:: DRVWRITE.BAT (v1.3)
::
::      Bla
::      P.O. Box NUL
::      Valley View, Ohio 44125 USA
::
::      E-Mail:   Blaware@FastMail.fm
::      Webpage:  http://www.NUL.nul/index.html
::
:: Feed the birds.  (Why?)  Well, they haven't pecked your eyes out!
::
::-#######################################################################-<
::
set DrvWrite=
if .%1.==.. goto MESSAGE
if not .%2.==.. goto HELP
echo -h/H?-?/?--HELP | find /i "%1" > NUL
if not errorlevel 1 goto HELP
freetest /? | find "Public domain free disk space checker by EA 2004-2005" > NUL
if errorlevel 1 goto MESSAGE
echo. | pkzip | find "PKZIP (R)   FAST!   Create/Update Utility   Version 2.50" > NUL
if errorlevel 1 goto MESSAGE
echo ACDEFGHIJKLMNOPQRSTUVWXYZ | find /i "%1" > NUL
if not errorlevel 1 goto 0G
goto HELP
:0G
freetest %1: | find "Cannot determine free space." > NUL
if not errorlevel 1 goto 0I
freetest %1: | find "Free space on drive" > NUL
if not errorlevel 1 goto 0H
::
:MESSAGE
echo.
echo  DRVWRITE.BAT -- Detect if a drive exists with a disk present and writable,
echo                  and SET the "DrvWrite" environment variable.
echo                  Type "DRVWRITE /?" for usage.
echo.
goto END
::
:HELP
echo.
echo  DRVWRITE.BAT -- Detect if a drive exists with a disk present and writable,
echo  ************    and SET the "DrvWrite" environment variable.
echo                                                      
echo                                                       Example: DRVWRITE a
echo           Usage: DRVWRITE [letter]                   
echo                  DRVWRITE ... Case iNsEnSiTiVe (except cannot be "drvwRite")
echo                    letter ... Drive letter A-Z (except B)
echo          Output:   YES/NO ... ECHOed to screen
echo.
echo                                                      
echo     Batch Usage: drvwRite [letter]                    Example: drvwRite F
echo     ------------ drvwRite ... Case sEnSiTiVe         
echo                    letter ... Drive letter A-Z (except B)
echo    Batch Output:      1/0 ... Value SET to "DrvWrite" EV (1=YES,0=NO)
echo    -------------
echo.
echo  Requirements: FREETEST.COM / PKZIP.EXE (v2.50)
echo.
goto END
::
:0H
pkzip %1:\~T#E@S!T.ZIP NUL > NUL
if errorlevel 1 goto 0I
echo .%0. | find "drvwRite" > NUL
if errorlevel 1 echo  YES
if not errorlevel 1 set DrvWrite=1
del %1:\~T#E@S!T.ZIP
goto END
:0I
echo .%0. | find "drvwRite" > NUL
if errorlevel 1 echo  NO
if not errorlevel 1 set DrvWrite=0
:END